<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title> MobiDoc | Booking </title>
    <link rel="stylesheet" href="styles/Nav_bar.css">

    <link rel="apple-touch-icon" sizes="180x180" href="../favicon/apple-touch-icon.png">
    <link rel="icon" type="image/png" sizes="32x32" href="../favicon/favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="../favicon/favicon-16x16.png">
    <link rel="manifest" href="../favicon/site.webmanifest">

    <!-- The core Firebase JS SDK is always required and must be listed first -->
    <!--    <script src="https://www.gstatic.com/firebasejs/8.6.1/firebase.js"></script>-->
    <script src="https://www.gstatic.com/firebasejs/8.6.1/firebase-app.js"></script>
    <script src="https://www.gstatic.com/firebasejs/8.6.1/firebase-auth.js"></script>
    <script src="https://www.gstatic.com/firebasejs/8.6.1/firebase-database.js"></script>
    <!--    <script src="https://www.gstatic.com/firebasejs/8.6.1/firebase-analytics.js"></script>-->
    <link type="text/css" rel="stylesheet" href="https://www.gstatic.com/firebasejs/ui/4.8.0/firebase-ui-auth.css" />
    <link rel="stylesheet" href="./styles/bookAppointments.css">

</head>
<body>

<!-- for the nav bar -->
<div class="wrapper">
    <nav>
        <input type="checkbox" id="show-search">
        <input type="checkbox" id="show-menu">
        <label for="show-menu" class="menu-icon"><i class="fas fa-bars"></i></label>
        <div class="content">
            <div class="logo"><a href="#">MobiDoc</a></div>
            <ul class="links">
                <li><a href="home.html">Home</a></li>
                <li><a href="profile.html">Profile</a></li>
                <li><a href="booking.html" class="active">Book Consultation</a></li>
                <li><a href="#" style="color: transparent">some blank string for some formatting so that it looks nice</a></li>
                <li>
                    <a href="appointments.html" class="desktop-link">Appointments</a>
                    <input type="checkbox" id="show-features">
                    <label for="show-features">Appointments</label>
                    <ul>
                        <li><a href="AppointmentTypes/AcceptedAppointments.html">Accepted Appointments</a></li>
                        <li><a href="AppointmentTypes/RejectedAppointments.html">Rejected Appointments</a></li>
                        <li><a href="AppointmentTypes/PendingAppointments.html">Pending Appointment</a></li>
                        <li><a href="AppointmentTypes/CompletedAppointments.html">Completed Appointments</a></li>
                    </ul>
                </li>
            </ul>
        </div>
    </nav>
</div>
<div style="padding-bottom: 200px"></div>

<!-- links this project to firebase -->

<script>

    let firebaseConfig = {
        apiKey: "AIzaSyB-ckD1wmZWj5c7RQIOyBvwFmQApBfEEMU",
        authDomain: "mobidoc-6a3ac.firebaseapp.com",
        databaseURL: "https://mobidoc-6a3ac-default-rtdb.firebaseio.com/",
        projectId: "mobidoc-6a3ac",
        storageBucket: "mobidoc-6a3ac.appspot.com",
        messagingSenderId: "311373483549",
        appId: "1:311373483549:web:3c840b29b14029ac4680f4",
        measurementId: "G-JFPKMPTGZ5"
    };
    // Initialize Firebase
    firebase.initializeApp(firebaseConfig);

</script>

<dl id="appList"></dl> <!-- refers to the space underneath the nav bar that contains all the appointments -->
</body>
<!--moved body tag from bottom of page to here-->

<!--popup for accepting a appointment request -->
<div id="accept_app_popup" class="popup" >
    <div class="popup-content">
        <div class="popup-header">
            <h2 style="text-align:center">Request Appointment</h2>
            <span class="popup-close">&times;</span>
        </div>
        <div class="popup-body">
<!--            <p>Please pick a time</p>-->
<!--            <p> <input class="form__group field" style="width: 30%" id="id_Stime" type="time" name="timePicker2" formtarget="01/01/2021" ></p>-->
           <p>Please pick the time of your appointment</p>
            <p> <input class="form__group field" style="width: 30%"  id="id_Etime" type="time" name="timePicker"></p>
            <p>Reason for Appointment</p>
            <textarea type="input" class="form__field" placeholder="reason for appointments" cols="100" 100 name="reason_for_appointment" id = "reasonForApp" required></textarea>
        </div>
        <div class="popup-footer">
            <button id="accept_app_btn" style="width: 50%">  Confirm  </button>
            <p id = "error1" class = "error"></p>
        </div>
    </div>
</div>



<script>
    let appList = document.getElementById("appList");

    firebase.auth().onAuthStateChanged(function (user) {
        if (user) {
            getDoctorList(user.uid);

        } else {
            window.location.href = "../index.html"; // redirects the user to the log in page
        }
    });




    const getDoctorList = (uid) => {
        let database = firebase.database();
        let ref = database.ref().child('DocSetADT');
        ref.orderByKey().once("value",snapshot => {
            if (snapshot.exists()) {
                snapshot.forEach(function (childSnapshot) {
                    let doc_id = childSnapshot.key;
                    let app = childSnapshot.val();

                    let DocN = app.doctorName
                    let docAvailDate = app.doctorAvailableDate
                    let docStartTime = app.doctorAvailableStartTime
                    let docEndTime = app.doctorAvailableEndTime
                    let all = DocN + " " + docAvailDate + " " +docStartTime+ " " +docEndTime
                    appList.innerHTML +=
                        "<div class = 'card' id='docCard' >" +

                        "<h2>Dr. " + app.doctorName +" " + app.doctorSurname + "</h2>" +
                    "<p>" + "Speciliazation:      "+ app.doctorSpecialization + "</p>" +
                        "<p>" + "Available on Day:      "+ app.doctorAvailableDate + "</p>" +
                        "<img src='https://i.pinimg.com/originals/68/fe/a2/68fea2a012cdd49ac888cbe9e95a7b6b.jpg' width='30%' height='50%' " +
                        "    alt='Doctors'>" +

                        "<table>" +
                        "<tr>" +
                        "<br/>" +
                        "<p>"+ "From: " + app.doctorAvailableStartTime  +"</p>"+
                       " </tr>" +
                        "<tr>" +
                        "<br/>" +
                        "<p>"+ "To: " + app.doctorAvailableEndTime  +"</p>"+
                        " </tr>" +
                        "<tr>" +
                        "<br/>" +
                        "<button id='" + app.doctorUid + "'  name='"+ all +"'   onClick='openBookApp(this.id,this.name)'>Book</button>" +
                        "</tr>" +
                        "</table>"
                        +"</div>"
                        +"<br/>"
                    ;

                });
            }
        });
    }

    function createNewApp(doc_id,DocName) {

        // let database = firebase.database();
        // let date = document.getElementById("id_date").value;
       let hours, minutes;
       let S_hours, S_minutes;
        // year = date.substring(0,4);
        // month = date.substring(5,7);
        // day = date.substring(8,11);
        // var Actualdate = day + "/" +month +"/" +year



        let Etime =  document.getElementById("id_Etime").value;
        hours = Etime.substring(0,2)
        minutes = Etime.substring(3,5)
        var ActualEtime = hours + ":" + minutes;


        // let Stime =  document.getElementById("id_Stime").value;
        // S_hours = Stime.substring(0,2)
        // S_minutes = Stime.substring(3,5)
        // var ActualStime = S_hours + ":" + S_minutes;

        let usersName="";
        var doctorName, doctorUid;
        var docNotes =" ";
        var appStatus = "pending";
        var costApp = "-";
        doctorName =DocName ;
        let AdoctorName= doctorName.substring(0,3)
        let date = doctorName.substring(doctorName.length-22)
            doctorUid = doc_id;
        let year, month, day, Shours, Sminutes, Ehours, Eminutes;
        year = date.substring(6,10)
        month = date.substring(3,5)
        day = date.substring(0,2)
        let Adate =  day + "/" +month +"/" +year

        Shours = date.substring(11,13)
        Sminutes = date.substring(14,16)
        Ehours = date.substring(17,19)
        Eminutes = date.substring(20,22)

        let docStime = Shours + ":" + Sminutes;
        let docEtime = Ehours + ":" + Eminutes;

        const currDate = new Date();
        // var valYear = parseInt(year);
        // var valMonth = parseInt(month);
        // var valDay = parseInt(day);
         var valSHours = parseInt(Shours);
        var valSMinutes = parseInt(Sminutes);

        var valEHours = parseInt(Ehours);
        var valEMinutes = parseInt(Eminutes);

        var valHours = parseInt(hours);
        var valMinutes = parseInt(minutes);

        //console.log(doctorName)
        // console.log(doctorUid)
        // console.log(date)
        // console.log(Shours)
        // console.log(Sminutes)
       // console.log("End time "+ ActualEtime)
        //console.log("Start time "+ActualStime)
if(valHours<valSHours){
    alert("Your selected time should be between: " + docStime + "  and  " + docEtime );

}
     else   if(valHours>valEHours){
            alert("Your selected time should be between: " + docStime + "  and  " + docEtime );

        }
     else if(valMinutes>0){
    alert("He.e chief");

}

else {
    firebase.auth().onAuthStateChanged(function (user) {
            if (user !=null) {
                let refPat = database.ref().child('Patients');
                refPat.orderByKey().once("value",snapshot => {
                    if (snapshot.exists()) {
                        snapshot.forEach(function (childSnapshot) {
                            let u = childSnapshot.val();
                            usersName = u.first_name;
                            if(user.uid === u.uid){
                                if(date === "" || time === ""){
                                    alert("Please pick a time and date");

                                }
                                // else if(valYear < currDate.getFullYear()){
                                //     alert("Please choose the correct year");
                                //
                                // }
                                // else if(valMonth < currDate.getMonth()){
                                //     alert("Please choose the correct month. You can't book for earlier months");
                                //
                                // }
                                // else if(valDay < currDate.getDate()){
                                //     alert("You can only book from today onwards");
                                //
                                // }
                                // else if((valHours < currDate.getHours()) || (valMinutes < currDate.getMinutes())){
                                //     alert("It's too late to book at this time. Please book an appropriate time");
                                //
                                // }
                                else {
                                    database.ref().child('Appointments').push({
                                        appointment_Cost:costApp ,
                                        //date_for_appointment:Adate,
                                        doctorUid:doctorUid,
                                       // doctor_Name:doctorName,
                                        notes:  docNotes,
                                        patientUid:user.uid,
                                        patient_Name:usersName,
                                        reason_for_appointment:document.getElementById("reasonForApp").value,
                                        status:appStatus,
                                        //time_for_appointment:Actualtime
                                    });
                                    let popup = document.getElementById("accept_app_popup");
                                    popup.style.display = "none";
                                    window.location.href = "./AppointmentTypes/PendingAppointments.html";
                                    // edited this to none then the popup disappears off screen after clicking accept button

                                }

                                ;
                            }
                        });
                    }
                });
            }

            else {
                window.location.href = "../index.html"; // redirects the user to the log in page
            }
        }
    );
}

        // console.log(AdoctorName)
        // console.log(year)
        // console.log(month)
        // console.log(day)




    }


    function openBookApp(appID,DocName) {
        let popup = document.getElementById("accept_app_popup");
        let close = document.getElementsByClassName("popup-close")[0];

        let button = document.getElementById("accept_app_btn");
        button.addEventListener('click', function() {
            createNewApp(appID,DocName);
        })

        popup.style.display = "block";//opens popup

        //closes popup if user clicks close (little cross upper right corner) or outside popup
        close.onclick = function() {
            popup.style.display = "none";
        }
        window.onclick = function(event) {
            if (event.target === popup) {
                popup.style.display = "none";
            }
        }
    }

    function updatemenu() {
        if (document.getElementById('responsive-menu').checked === true) {
            document.getElementById('menu').style.borderBottomRightRadius = '0';
            document.getElementById('menu').style.borderBottomLeftRadius = '0';
        }
        else{
            document.getElementById('menu').style.borderRadius = '0px';
        }
    }
</script>

<!-- links the js file to the html file under Appointments-->

</html>